/* debug_bgp_bestpath_prefix => "debug bgp bestpath <A.B.C.D/M|X:X::X:X/M>$bestpath" */
DEFUN_CMD_FUNC_DECL(debug_bgp_bestpath_prefix)
#define funcdecl_debug_bgp_bestpath_prefix static int debug_bgp_bestpath_prefix_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const struct prefix * bestpath,\
	const char * bestpath_str __attribute__ ((unused)))
funcdecl_debug_bgp_bestpath_prefix;
DEFUN_CMD_FUNC_TEXT(debug_bgp_bestpath_prefix)
{
	int _i;
	unsigned _fail = 0, _failcnt = 0;
	struct prefix bestpath = { };
	const char *bestpath_str = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
		_fail = 0;
		if (!strcmp(argv[_i]->varname, "bestpath")) {
			bestpath_str = argv[_i]->arg;
			_fail = !str2prefix(argv[_i]->arg, &bestpath);
		}
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
	}
	if (_failcnt)
		return CMD_WARNING;
	return debug_bgp_bestpath_prefix_magic(self, vty, argc, argv, &bestpath, bestpath_str);
}

